
#include <time.h>
#pragma comment(lib, "Msimg32.lib")

int g_CodeLength = 0;
int g_CodeWidth,g_CodeHeight;
char * g_cLimitCodeHTML;
DWORD g_dwLimitCodeHTML = 0;

HBITMAP CreateBmp(char* szText);
unsigned char* GetBitmapData(HBITMAP hBitmap, DWORD &lSize);
bool LoadCodeConfig(CString strConfigFile);

bool LoadCodeConfig(CString strConfigFile)
{

g_CodeLength=::GetPrivateProfileInt(_T("Code"),_T("Length"),4,strConfigFile);
if ( g_CodeLength < 1 || g_CodeLength > 24 )
{
	g_CodeLength = 0;
	return false;
}

g_CodeWidth=::GetPrivateProfileInt(_T("Code"),_T("Width"),300,strConfigFile);
if ( g_CodeWidth < 1 || g_CodeWidth > 512 )
{
	g_CodeWidth = 300;
}

g_CodeHeight=::GetPrivateProfileInt(_T("Code"),_T("height"),100,strConfigFile);
if ( g_CodeHeight < 1 || g_CodeHeight > 512 )
{
	g_CodeHeight = 100;
}

return true;
}

bool IsBlackPoint(BYTE* pSrcBits, int iBytesPerPixel, int bmWidth, int bmHeight, int x, int y)
{
	if (x<0 || x>=bmWidth || y<0 || y>=bmHeight)
		return false;
	if (iBytesPerPixel == 2) // 16 bits
	{
		WORD wPixel = *((WORD*)(pSrcBits + (iBytesPerPixel * (x + y * bmWidth))));
		return wPixel == 0;
	}
	int iR = pSrcBits[iBytesPerPixel * (x + y * bmWidth) + 2];
	int iG = pSrcBits[iBytesPerPixel * (x + y * bmWidth) + 1];
	int iB = pSrcBits[iBytesPerPixel * (x + y * bmWidth) + 0];
	return iR == 0 && iG == 0 && iB == 0;
}
int GetRight(HBITMAP hSrcBmp)
{
	if (hSrcBmp == 0)
		return 0;
	
	HBITMAP hRetBmp = 0;
	
	int iBytesPerPixel = 4;
	BITMAP bm = { 0 };
	int nGetRet = 0;
	if (!(nGetRet = GetObject(hSrcBmp, sizeof(BITMAP), &bm)))
	{
		DWORD dwErr = GetLastError();
		return 0;
	}
	{
		if (bm.bmBitsPixel == 16 || bm.bmBitsPixel == 24 || bm.bmBitsPixel == 32)
		{
			iBytesPerPixel = bm.bmBitsPixel / 8;
			LONG dwLenBuff = iBytesPerPixel * bm.bmWidth * bm.bmHeight;
			BYTE *pSrcBits = new BYTE[dwLenBuff];
			if (pSrcBits)
			{
				LONG lSrcSize = 0L;
				if (lSrcSize = GetBitmapBits(hSrcBmp, dwLenBuff, pSrcBits))
				{
					int nLeft = 10000, nTop = 10000, nRight = 0, nBottom = 0;
					int x = 0, y = 0;
					for (x = bm.bmWidth-1; x >= 0; x--)
					{
						for (y = 0; y < bm.bmHeight; y++)
						{
							if (IsBlackPoint(pSrcBits, iBytesPerPixel, bm.bmWidth, bm.bmHeight, x, y))
							{
								delete []pSrcBits;
								return x;
							}
						}
					}
				}
				
				delete []pSrcBits;
				pSrcBits = 0;
			}
		}
	}
	return 0;
}

int GetCharRight(HDC hDC, HFONT hFont, int nWD, int nHG, RECT& rt, const char* szt)
{
	HDC hMemDC = CreateCompatibleDC(hDC);
	HBITMAP hMemBmp = CreateCompatibleBitmap(hDC, nWD, nHG);
	HBITMAP hOldBmp = (HBITMAP)SelectObject(hMemDC, hMemBmp);
	RECT rc = {0, 0, nWD, nHG};
	FillRect(hMemDC, &rc, (HBRUSH)GetStockObject(WHITE_BRUSH));
	HFONT hOldFont = (HFONT)SelectObject(hMemDC, hFont);
	SetBkMode(hMemDC, TRANSPARENT);
	DrawText(hMemDC, szt, -1, &rt, DT_SINGLELINE | DT_VCENTER);
	int nR = GetRight(hMemBmp);
	SelectObject(hMemDC, hOldFont);
	SelectObject(hMemDC, hOldBmp);
	DeleteObject(hMemBmp);
	DeleteDC(hMemDC);
	return nR;
}

HBITMAP CreateBmp(char* szText)
{
	HDC hDC = CreateDCA("DISPLAY", NULL, NULL, NULL); 
	//ͼƬС
	HDC hMemDC = CreateCompatibleDC(hDC);
	HBITMAP hMemBitmap = CreateCompatibleBitmap(hDC, g_CodeWidth, g_CodeHeight);
	HBITMAP hOldBitmap = (HBITMAP)SelectObject(hMemDC, hMemBitmap);
	
	RECT rc = {0, 0, g_CodeWidth, g_CodeHeight};
	FillRect(hMemDC, &rc, (HBRUSH)GetStockObject(WHITE_BRUSH));

	srand(time(0));
	int i = 0;
	// random draw line
	for (i = 0; i < 4; i++)
	{
		int x1 = rand() % g_CodeWidth;
		int y1 = rand() % g_CodeHeight;
		int x2 = rand() % g_CodeWidth;
		int y2 = rand() % g_CodeHeight;
		int w = 2;
		int r = 0;
		int g = 0;
		int b = 0;
		COLORREF cr = RGB(r, g, b);
		HPEN hPen = CreatePen(PS_SOLID, w, cr);
		HPEN hOldPen = (HPEN)SelectObject(hMemDC, hPen);
		MoveToEx(hMemDC, x1, y1, NULL);
		LineTo  (hMemDC, x2, y2);
		SelectObject(hMemDC, hOldPen);
		DeleteObject(hPen);
	}

	// random draw point
	for (i = 0; i < 500; i++)
	{
		int x = rand() % g_CodeWidth;
		int y = rand() % g_CodeHeight;
		int w = rand() % 3;
		int d = rand() % 4;
		COLORREF cr = RGB(0, 0, 0);
		HPEN hPen = CreatePen(PS_SOLID, w, cr);
		HPEN hOldPen = (HPEN)SelectObject(hMemDC, hPen);
		MoveToEx(hMemDC, x, y, NULL);
		LineTo(hMemDC, x+d, y+d);

		SelectObject(hMemDC, hOldPen);
		DeleteObject(hPen);
	}

	//
	char szFont[1][16] = {"Arial"};

	int ncr = 0;
	for (i = 0; i < g_CodeLength; i++)
	{
		//  б б 
		int w = rand() % (g_CodeWidth/g_CodeLength); if (w<40) w=40;
		int h = rand() % 80;       if (h<44) h=40;
		int e = rand() % 280 + 100;
		int o = rand() % 280 + 100;
		int b = rand() % 100 + 900;
		HFONT hFont = CreateFontA(h, 0, e, o, b, b%2, 0, 0, CHINESEBIG5_CHARSET, OUT_CHARACTER_PRECIS, CLIP_CHARACTER_PRECIS,DEFAULT_QUALITY, 1, szFont[0]);
		RECT rt = {0, 0, 0, 0};
		HFONT hOldFont = (HFONT)SelectObject(hMemDC, hFont);
		SetBkMode(hMemDC, TRANSPARENT);
		char szt[2] = { szText[i + 5], 0};
		DrawText(hMemDC, szt, -1, &rt, DT_CALCRECT | DT_SINGLELINE | DT_VCENTER);
		int nw = rt.right-rt.left;
		rt.left = i * ( rand() % ((g_CodeWidth)/(g_CodeLength+1)) );	if (rt.left < ncr-6) rt.left = ncr-6;
		rt.right = rt.left+nw+20;
		rt.top = 0;
		rt.bottom = g_CodeHeight;
		DrawText(hMemDC, szt, -1, &rt, DT_SINGLELINE | DT_VCENTER);
		rt.left   += 1;
		rt.top    += 1;
		rt.right  += 1;
		rt.bottom += 1;
		DrawText(hMemDC, szt, -1, &rt, DT_SINGLELINE | DT_VCENTER);
		ncr = GetCharRight(hMemDC, hFont, g_CodeWidth, g_CodeHeight, rt, szt);
		SelectObject(hMemDC, hOldFont);
		DeleteObject(hFont);
	}

	::SelectObject(hMemDC, hOldBitmap);
	::DeleteDC(hMemDC);
	::DeleteDC(hDC);

	return hMemBitmap;
}

unsigned char* GetBitmapData(HBITMAP hBitmap, DWORD &lSize)
{
	HDC hDC; 
	//ǰֱÿռֽ 
	int iBits; 
	//λͼÿռֽ 
	WORD wBitCount; 
	//ɫС λͼֽڴС λͼļС  дļֽ 
	DWORD dwPaletteSize=0, dwBmBitsSize=0, dwDIBSize=0, dwWritten=0; 
	//λͼԽṹ 
	BITMAP Bitmap; 
	//λͼļͷṹ 
	BITMAPFILEHEADER *bmfHdr; 
	//λͼϢͷṹ 
	BITMAPINFOHEADER bi; 
	//ָλͼϢͷṹ 
	LPBITMAPINFOHEADER lpbi; 
	//ļڴɫ 
	HANDLE hPal,hOldPal=NULL; 
	
	//λͼļÿռֽ 
	hDC = CreateDCA("DISPLAY", NULL, NULL, NULL); 
	iBits = GetDeviceCaps(hDC, BITSPIXEL) * GetDeviceCaps(hDC, PLANES); 
	DeleteDC(hDC); 
	if (iBits <= 1) wBitCount = 1; 
	else if (iBits <= 4) wBitCount = 4; 
	else if (iBits <= 8) wBitCount = 8; 
	else wBitCount = 24; 
	
	GetObject(hBitmap, sizeof(Bitmap), (LPSTR)&Bitmap); 
	bi.biSize = sizeof(BITMAPINFOHEADER); 
	bi.biWidth = Bitmap.bmWidth; 
	bi.biHeight = Bitmap.bmHeight; 
	bi.biPlanes = Bitmap.bmPlanes; 
	bi.biBitCount = wBitCount; 
	bi.biCompression = BI_RGB; 
	bi.biSizeImage = 0; 
	bi.biXPelsPerMeter = 0; 
	bi.biYPelsPerMeter = 0; 
	bi.biClrImportant = 0; 
	bi.biClrUsed = 0; 
	
	dwBmBitsSize = ((Bitmap.bmWidth * wBitCount + 31) / 32) * 4 * Bitmap.bmHeight; 
	
	//Ϊλͼݷڴ
	lSize = dwBmBitsSize + dwPaletteSize + sizeof(BITMAPINFOHEADER)+sizeof(BITMAPFILEHEADER);
	unsigned char * lpDib = new unsigned char [lSize];
	if (lpDib == 0)
		return 0;
	bmfHdr = (LPBITMAPFILEHEADER)lpDib; 
	lpbi = (LPBITMAPINFOHEADER) (lpDib+sizeof(BITMAPFILEHEADER));
	*lpbi = bi; 
	
	// ɫ 
	hPal = GetStockObject(DEFAULT_PALETTE); 
	if (hPal) 
	{ 
		hDC = ::GetDC(NULL); 
		hOldPal = ::SelectPalette(hDC, (HPALETTE)hPal, FALSE); 
		RealizePalette(hDC); 
	} 
	
	// ȡõɫµֵ 
	GetDIBits(hDC, hBitmap, 0, (UINT) Bitmap.bmHeight, (LPSTR)lpbi + sizeof(BITMAPINFOHEADER) 
		+dwPaletteSize, (BITMAPINFO *)lpbi, DIB_RGB_COLORS); 
	
	//ָɫ
	if (hOldPal) 
	{ 
		::SelectPalette(hDC, (HPALETTE)hOldPal, TRUE); 
		RealizePalette(hDC); 
		::ReleaseDC(NULL, hDC); 
	} 
	
	// λͼļͷ 
	bmfHdr->bfType = 0x4D42; // "BM" 
	dwDIBSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + dwPaletteSize + dwBmBitsSize; 
	bmfHdr->bfSize = dwDIBSize; 
	bmfHdr->bfReserved1 = 0; 
	bmfHdr->bfReserved2 = 0; 
	bmfHdr->bfOffBits = (DWORD)sizeof(BITMAPFILEHEADER) + (DWORD)sizeof(BITMAPINFOHEADER) + dwPaletteSize; 
	return lpDib;
}